Skip to content

# Regex

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the regular expressions helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024, 2025 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `RegexHelper`

Simplify the regex matching and usage.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`regex` | `str` | The regex to use. | `None`
`escape_regex` | `bool` | Escapes the given regex. | `False`

Source code in `PyFunceble/helpers/regex.py`

     57
     58
     59
     60
     61
     62
     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223

    class RegexHelper:
        """
        Simplify the regex matching and usage.

        :param str regex: The regex to use.
        :param escape_regex: Escapes the given regex.
        """

        _regex: Optional[str] = None
        _compiled: Optional[re.Pattern] = None
        escape_regex: bool = False

        def __init__(self, regex: Optional[str] = None, escape_regex: bool = False):
            self.escape_regex = escape_regex

            if regex is not None:
                self.regex = regex

        @property
        def regex(self) -> Optional[str]:
            """
            Provides the current state of the :code:`_regex` attribute.
            """

            return self._regex

        @regex.setter
        def regex(self, value: str) -> None:
            """
            Sets the regex to work with.

            :param value:
                The regex to work with.

            :raise TypeError:
                When :code:`value` is not :py:class:`str`.
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(str)} given.")

            if not self.escape_regex:
                self._regex = value
            else:
                self._regex = re.escape(value)

            self._compiled = re.compile(self._regex)

        def set_regex(self, value: str) -> "RegexHelper":
            """
            Sets the regex to work with.

            :param value:
                The regex to work with.

            :raise TypeError:
                When :code:`value` is not :py:class:`str`.
            """

            self.regex = value

            return self

        def get_not_matching_list(self, data: List[str]) -> List[str]:
            """
            Returns the strings which does not the match the regex
            in the given data.
            """

            return [x for x in data if not self._compiled.search(str(x))]

        def get_matching_list(self, data: List[str]) -> List[str]:
            """
            Returns the strings which does the match the regex
            in the given data.
            """

            return [x for x in data if self._compiled.search(str(x))]

        def match(
            self,
            data: str,
            *,
            rematch: bool = False,
            group: int = 0,
            return_match: bool = True,
        ) -> Union[bool, str, List[str]]:
            """
            Checks if the given data match the given regex string.

            :param data: The data to work with.
            :param rematch:
                The equivalent of the $BASH_REMATCH but in Python.

                It's basically a list of all groups.
            :param group:
                The group to return when return_match is set to :code:`True`.
            :param return_match:
                Return the part that match the given regex string.
            """

            result = []

            if rematch:
                pre_result = self._compiled.findall(data)
            else:
                pre_result = self._compiled.search(data)

            if return_match and pre_result:
                if rematch:
                    for res in pre_result:
                        if isinstance(res, tuple):
                            result.extend(list(res))
                        else:  # pragma: no cover ## Safety
                            result.append(res)

                    if group != 0:
                        return result[group]
                else:
                    result = pre_result.group(group).strip()

                return result

            if not return_match and pre_result:
                return True
            return False

        def replace_match(
            self,
            data: str,
            replacement: str,
            *,
            occurences: int = 0,
            multiline: bool = False,
        ) -> str:
            """
            Replaces the string which match the regex string with
            the given replacement.

            :param data: The data to work with.
            :param replacement: The replacement of the matched regex.
            :param occurences:
                The number of occurences to replace.

                .. note::
                    :code:`0` means all occurences.
            """

            if isinstance(replacement, str):
                return re.sub(
                    self.regex,
                    replacement,
                    data,
                    count=occurences,
                    flags=re.MULTILINE if multiline else 0,
                )
            return data

        def split(self, data: str) -> List[str]:
            """
            Split the reference of the given regex.

            :param str data: The data to work with.
            :rtype: list
            """

            return self._compiled.split(data)

### `regex` `property` `writable`

Provides the current state of the :code:`_regex` attribute.

### `get_matching_list(data)`

Returns the strings which does the match the regex in the given data.

Source code in `PyFunceble/helpers/regex.py`

    128
    129
    130
    131
    132
    133
    134

    def get_matching_list(self, data: List[str]) -> List[str]:
        """
        Returns the strings which does the match the regex
        in the given data.
        """

        return [x for x in data if self._compiled.search(str(x))]

### `get_not_matching_list(data)`

Returns the strings which does not the match the regex in the given data.

Source code in `PyFunceble/helpers/regex.py`

    120
    121
    122
    123
    124
    125
    126

    def get_not_matching_list(self, data: List[str]) -> List[str]:
        """
        Returns the strings which does not the match the regex
        in the given data.
        """

        return [x for x in data if not self._compiled.search(str(x))]

### `match(data, *, rematch=False, group=0, return_match=True)`

Checks if the given data match the given regex string.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`data` | `str` | The data to work with. | required
`rematch` | `bool` | The equivalent of the $BASH_REMATCH but in Python. It's basically a list of all groups. | `False`
`group` | `int` | The group to return when return_match is set to :code:`True`. | `0`
`return_match` | `bool` | Return the part that match the given regex string. | `True`

Source code in `PyFunceble/helpers/regex.py`

    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182

    def match(
        self,
        data: str,
        *,
        rematch: bool = False,
        group: int = 0,
        return_match: bool = True,
    ) -> Union[bool, str, List[str]]:
        """
        Checks if the given data match the given regex string.

        :param data: The data to work with.
        :param rematch:
            The equivalent of the $BASH_REMATCH but in Python.

            It's basically a list of all groups.
        :param group:
            The group to return when return_match is set to :code:`True`.
        :param return_match:
            Return the part that match the given regex string.
        """

        result = []

        if rematch:
            pre_result = self._compiled.findall(data)
        else:
            pre_result = self._compiled.search(data)

        if return_match and pre_result:
            if rematch:
                for res in pre_result:
                    if isinstance(res, tuple):
                        result.extend(list(res))
                    else:  # pragma: no cover ## Safety
                        result.append(res)

                if group != 0:
                    return result[group]
            else:
                result = pre_result.group(group).strip()

            return result

        if not return_match and pre_result:
            return True
        return False

### `replace_match(data, replacement, *, occurences=0, multiline=False)`

Replaces the string which match the regex string with the given replacement.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`data` | `str` | The data to work with. | required
`replacement` | `str` | The replacement of the matched regex. | required
`occurences` | `int` | The number of occurences to replace. .. note:: :code:`0` means all occurences. | `0`

Source code in `PyFunceble/helpers/regex.py`

    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213

    def replace_match(
        self,
        data: str,
        replacement: str,
        *,
        occurences: int = 0,
        multiline: bool = False,
    ) -> str:
        """
        Replaces the string which match the regex string with
        the given replacement.

        :param data: The data to work with.
        :param replacement: The replacement of the matched regex.
        :param occurences:
            The number of occurences to replace.

            .. note::
                :code:`0` means all occurences.
        """

        if isinstance(replacement, str):
            return re.sub(
                self.regex,
                replacement,
                data,
                count=occurences,
                flags=re.MULTILINE if multiline else 0,
            )
        return data

### `set_regex(value)`

Sets the regex to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The regex to work with. | required

Raises:

Type | Description
--- | ---
`TypeError` | When :code:`value` is not class:`str`.

Source code in `PyFunceble/helpers/regex.py`

    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118

    def set_regex(self, value: str) -> "RegexHelper":
        """
        Sets the regex to work with.

        :param value:
            The regex to work with.

        :raise TypeError:
            When :code:`value` is not :py:class:`str`.
        """

        self.regex = value

        return self

### `split(data)`

Split the reference of the given regex.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`data` | `str` | The data to work with. | required

Source code in `PyFunceble/helpers/regex.py`

    215
    216
    217
    218
    219
    220
    221
    222
    223

    def split(self, data: str) -> List[str]:
        """
        Split the reference of the given regex.

        :param str data: The data to work with.
        :rtype: list
        """

        return self._compiled.split(data)